property pNumTeams, pRoomComponentObj, pFigureSystemObj, pHiliterObj

on construct me
pRoomComponentObj = GetObject(#room_component)
if pRoomComponentObj = FALSE then
return error(me, "Avatar manager failed to initialize", #construct)

end if
registerMessage(#create_user, me.getID(), #setAvatarEventListener)
return TRUE

end

on deconstruct me
me.displayAvatarInfo(FALSE)
unregisterMessage(#create_user, me.getID())
GetObject(#session).Remove("game_number_of_teams")
return TRUE

end

on Refresh me, tTopic, tdata
case tTopic of
#set_number_of_teams:
pNumTeams = tdata
GetObject(#session).set("game_number_of_teams", tdata)

#snowwar_event_2:
me.getGameSystem().executeGameObjectEvent(tdata[#id], #set_target, tdata)

#snowwar_event_3:
me.getGameSystem().executeGameObjectEvent(tdata[#id], #start_throw_snowball, tdata)
me.getGameSystem().executeGameObjectEvent(tdata[#id], #substract_ball_count)

#snowwar_event_4:
me.getGameSystem().executeGameObjectEvent(tdata[#id], #start_throw_snowball, tdata)
me.getGameSystem().executeGameObjectEvent(tdata[#id], #substract_ball_count)

#snowwar_event_5:
playSound("LS-hit-" & random(2))
tGameSystem = me.getGameSystem()
tGameSystem.executeGameObjectEvent(tdata[#id], #substract_hit_points)
if pNumTeams = 1 then
tAwardScore = TRUE

else
tThisTeam = tGameSystem.getGameObjectProperty(tdata[#id], #team_id)
tThatTeam = tGameSystem.getGameObjectProperty(string(tdata[#int_thrower_id]), #team_id)
if tThisTeam <> tThatTeam then tAwardScore = TRUE

end if
if tAwardScore then
tGameSystem.executeGameObjectEvent(string(tdata[#int_thrower_id]), #award_hit_score)

end if
#snowwar_event_7:
me.getGameSystem().executeGameObjectEvent(tdata[#id], #start_create_snowball)

#snowwar_event_9:
tGameSystem = me.getGameSystem()
tHitDirection8 = tGameSystem.getGeometry().direction360to8(tdata[#hit_direction])
playSound("LS-hit-3")
tGameSystem.executeGameObjectEvent(tdata[#id], #start_stunned, [#hit_direction: tHitDirection8])
tGameSystem.executeGameObjectEvent(tdata[#id], #zero_ball_count)
if pNumTeams = 1 then
tAwardScore = TRUE

else
tThisTeam = tGameSystem.getGameObjectProperty(tdata[#id], #team_id)
tThatTeam = tGameSystem.getGameObjectProperty(string(tdata[#int_thrower_id]), #team_id)
if tThisTeam <> tThatTeam then tAwardScore = TRUE

end if
if tAwardScore then
tGameSystem.executeGameObjectEvent(string(tdata[#int_thrower_id]), #award_kill_score)

end if
otherwise:
return error(me, "Undefined event!" && tTopic && "for" && me.pID, #Refresh)

end case
return TRUE

end

on setAvatarEventListener me, tName, tID
tRoom = GetObject(#room_component)
if tRoom = FALSE then return FALSE

tObject = tRoom.getUserObject(tID)
if tObject = FALSE then return FALSE

call(#setAvatarEventListener, tObject, me.getID())
return TRUE

end

on eventProcSnowwarUserRollOver me, tEvent, tID, tProp
tRoom = GetObject(#room_component)
if tRoom = FALSE then return FALSE

tObject = tRoom.getUserObject(tID)
if tObject = FALSE then return FALSE

tGameSystem = me.getGameSystem()
if tEvent = #mouseEnter then
tName = tObject.getName()
tOwnPlayer = FALSE
if not tGameSystem.getSpectatorModeFlag() then
if tName = GetObject(#session).GET(#userName) then
tOwnPlayer = TRUE

else
if tGameSystem.getGamestatus() = #game_started then
tMemberNum = getmemnum("sw_crosshair")
tMemberNum2 = getmemnum("sw_crosshair.mask")
if tMemberNum <> 0 and tMemberNum2 <> 0 then
cursor([tMemberNum, tMemberNum2])

end if
end if
end if
end if
tloc = tObject.getLocation()
tloc = tGameSystem.convertTileToWorldCoordinate(tloc[1], tloc[2], 0)
tloc = tGameSystem.convertWorldToScreenCoordinate(tloc[1], tloc[2], 0)
tScore = tGameSystem.getGameObjectProperty(tObject.getAvatarId(), #score)
return me.displayAvatarInfo(tName, tScore, tObject.getTeamId(), tloc, tOwnPlayer)

else
setcursor(0)
return me.displayAvatarInfo(FALSE)

end if
end

on displayAvatarInfo me, tName, tScore, tTeamId, tloc, tOwnPlayer
if stringp(tName) then
if pHiliterObj <> void() then return TRUE

pHiliterObj = createObject(#temp, getClassVariable("snowwar.object_avatar.roomobject.hiliter.class"))
if pHiliterObj = 0 then return FALSE

return pHiliterObj.display(tName, tScore, tTeamId, tloc, tOwnPlayer)

else
if pHiliterObj <> void() then
pHiliterObj.hide()

end if
pHiliterObj = void()

end if
return TRUE

end
