property pReady, pHiliteSpriteNum, pFramework, pAvatarAction, pInvincible, pInvincibleCounter, pTeamId, pAvatarId, pDump, pActionPartList

on construct me
pActionPartList = ["bd", "sh"]
pReady = FALSE
pDump = 0
pAvatarAction = [:]
pAvatarAction[#tag] = EMPTY
if not objectp(me.ancestor) then return FALSE

return me.ancestor.construct()

end

on deconstruct me
pReady = FALSE
if pHiliteSpriteNum > 0 then releaseSprite(pHiliteSpriteNum)
if not objectp(me.ancestor) then return TRUE

return me.ancestor.deconstruct()

end

on define me, tdata
me.pPartClass = getVariableValue("snowwar.bodypart.class")
pTeamId = string(tdata[#team_id])
pAvatarId = string(tdata[#human_id])
callAncestor(#define, me, tdata)
case tdata[#activity_state] of
1:
me.gameObjectAction("start_create")

2:
tParams = [:]
tParams.addProp(#hit_direction, tdata[#body_direction])
me.gameObjectAction("start_stunned", tParams)
me.gameObjectAction("next_stunned")

3:
me.gameObjectAction("start_invincible")

end case
pReady = TRUE
me.setOwnHiliter(TRUE)
return TRUE

end

on select me
if pFramework = void() then pFramework = GetObject(#snowwar_gamesystem)

if pFramework.getGamestatus() <> #game_started then return FALSE
if pFramework.getSpectatorModeFlag() then return FALSE
if not GetObject(#session).exists("user_game_index") then return FALSE

tUserIndex = GetObject(#session).GET("user_game_index")
if tUserIndex = FALSE then
return error(me, "Own player missing the game object index!", #select)

end if
tIsOwnAvatar = (pAvatarId = tUserIndex)
if tIsOwnAvatar then
pFramework.executeGameObjectEvent(pAvatarId, #send_create_snowball)

else
if the shiftDown or the optionDown then -- jump 27
pFramework.executeGameObjectEvent(pAvatarId, #send_throw_at_player, [#target_id: pAvatarId, #trajectory: 2])

else
pFramework.executeGameObjectEvent(pAvatarId, #send_throw_at_player, [#target_id: pAvatarId, #trajectory: 0])

end if
end if
return FALSE

end

on setAvatarEventListener me, tTargetID
tsprite = me.pMatteSpr
if not ilk(tsprite) = #sprite then return FALSE

tsprite.registerProcedure(#eventProcSnowwarUserRollOver, tTargetID, #mouseEnter)
tsprite.registerProcedure(#eventProcSnowwarUserRollOver, tTargetID, #mouseLeave)
return TRUE

end

on gameObjectRefreshLocation me, tX, tY, tH, tDirHead, tDirBody
me.resetValues(tX, tY, tH, tDirHead, tDirBody)
return TRUE

end

on gameObjectNewMoveTarget me, tX, tY, tH, tDirHead, tDirBody, tAction
me.pMoveTime = 300
tX = integer(tX)
tY = integer(tY)
tH = integer(tH)
me.resetValues(me.pLocX, me.pLocY, me.pLocH, tDirHead, tDirBody)
me.setProp(#pAvatarAction, #tag, EMPTY)
me.pMainAction = "wlk"
me.pMoving = TRUE
if me.pGeometry = FALSE then return FALSE

me.pStartLScreen = me.pGeometry.getScreenCoordinate(me.pLocX, me.pLocY, me.pLocH)
me.pDestLScreen = me.pGeometry.getScreenCoordinate(tX, tY, tH)
me.pMoveStart = the milliSeconds
call(#defineAct, me.getDefinedPartList(pActionPartList), "wlk")
me.Refresh(me.pLocX, me.pLocY, me.pLocH)
return TRUE

end

on gameObjectMoveDone me, tX, tY, tH, tDirHead, tDirBody, tAction
me.pAnimCounter = 0
me.resetValues(tX, tY, tH, tDirHead, tDirBody)
call(#reset, me.pPartList)
me.setHumanSpriteLoc()
me.setOwnHiliter(1)
return TRUE
end

on gameObjectAction me, tAction, tdata
case tAction of
"start_throw":
me.resetValues(me.pLocX, me.pLocY, me.pLocH, tdata, tdata)
me.Refresh(me.pLocX, me.pLocY, me.pLocH)
call(#defineAct, me.getDefinedPartList(pActionPartList), "tr1")
me.pChanges = TRUE
pAvatarAction[#tag] = "throw"
return me.delay(100, #gameObjectAction, "next_throw")

"next_throw":
if pAvatarAction[#tag] <> "throw" then -- jump 11
return TRUE
end if -- jump 11 landing
pAvatarAction[#tag] = EMPTY
call(#reset, me.pPartList)
me.pChanges = TRUE
call(#defineAct, me.getDefinedPartList(pActionPartList), "tr2")
if pDump then put "next_throw calling timer_reset_figure"

return me.delay(300, #gameObjectAction, "timer_reset_figure")

"timer_reset_figure":
if pAvatarAction[#tag] <> EMPTY then return TRUE

me.gameObjectAction("reset_figure", tdata)

"reset_figure":
me.pInvincible = 0
me.pMainAction = "std"
if pAvatarAction.findPos(#originaldirection) > 0 then
me.pDirection = pAvatarAction[#originaldirection]

end if
pAvatarAction[#tag] = EMPTY
if ilk(me.pSprite) = #sprite then me.pSprite.blend = 100

me.resetValues(me.pLocX, me.pLocY, me.pLocH, me.pDirection, me.pDirection)
me.arrangeParts()
call(#reset, me.pPartList)
me.pChanges = TRUE

"start_create":
pAvatarAction[#tag] = EMPTY
tDirection = me.pDirection - (me.pDirection mod 2)
call(#defineDir, me.pPartList, tDirection)
me.pMainAction = "pck"
call(#defineAct, me.getDefinedPartList(pActionPartList), "pck")
me.pChanges = TRUE
me.arrangeParts()
me.render()

"start_stunned":
me.gameObjectMoveDone(me.pLocX, me.pLocY, me.pLocH, me.pDirection, me.pDirection)
tBallDirection = (tdata[#hit_direction] - (tdata[#hit_direction] mod 2))
tMyDirection = (me.pDirection - (me.pDirection mod 2))
if tBallDirection <> tMyDirection and (tBallDirection mod 4) = (tMyDirection mod 4) then -- jump 14
tDeathDirection = tMyDirection
tFaceUp = TRUE

else
tDeathDirection = tBallDirection
tFaceUp = FALSE

end if
pAvatarAction[#direction] = tDeathDirection
pAvatarAction[#originaldirection] = me.pDirection
pAvatarAction[#frame] = 1
pAvatarAction[#tag] = "dead"
if tFaceUp then -- jump 25
pAvatarAction[#facedown] = FALSE
pAvatarAction[#member] = "fb"

else
pAvatarAction[#facedown] = TRUE
pAvatarAction[#member] = "ff"

end if
me.pDirection = tDeathDirection
call(#defineDir, me.pPartList, me.pDirection)
call(#defineAct, me.getDefinedPartList(pActionPartList), pAvatarAction[#member] & "1")
me.pMainAction = "std"
me.arrangeParts()
me.render()
return me.delay(80, #gameObjectAction, "next_stunned")

"next_stunned":
if pAvatarAction[#tag] <> "dead" then return me.gameObjectAction("reset_figure")

repeat with tPart in me.pPartList
tPart.pAction = "foo"

end repeat
pAvatarAction[#frame] = 2
call(#defineDirMultiple, me.pPartList, pAvatarAction[#direction], pActionPartList)
call(#defineAct, me.getDefinedPartList(pActionPartList), pAvatarAction[#member] & "2")
me.pChanges = TRUE
me.arrangeParts()
me.render()

"start_invincible":
pAvatarAction[#tag] = EMPTY
me.gameObjectAction("reset_figure")
me.pInvincible = TRUE
me.pInvincibleCounter = 0

end case
return TRUE

end

on prepare me
if me.pInvincible then
me.pInvincibleCounter = me.pInvincibleCounter + 1
if me.pInvincibleCounter > 2 then
me.setBlendInvincible()
me.pInvincibleCounter = 0

end if
end if
me.pAnimCounter = (me.pAnimCounter + 1) mod 4
if me.pMoving then
tFactor = float(the milliSeconds - me.pMoveStart) / me.pMoveTime
if tFactor > 1.0 then tFactor = 1.0

me.pScreenLoc = (me.pDestLScreen - me.pStartLScreen) * tFactor + me.pStartLScreen
me.pChanges = TRUE

end if
end

on update me
if pAvatarAction[#tag] = "dead" then return TRUE

me.pSync = not me.pSync
if me.pSync then me.prepare()
else me.render()

end

on render me
if not me.pChanges then return FALSE
if not pReady then return FALSE

me.pChanges = FALSE
if me.pMainAction = "sit" then
tSize = me.getProp(#pCanvasSize, #std)
me.pShadowSpr.castNum = getmemnum(me.pPeopleSize & "_sit_sd_001_" & me.getProp(#pFlipList, (me.pDirection + 1)) & "_0")

else if me.pMainAction = "lay" then
tSize = me.getProp(#pCanvasSize, #lay)
me.pShadowSpr.castNum = 0
me.pShadowFix = FALSE

else
tSize = me.getProp(#pCanvasSize, #std)
if pAvatarAction[#tag] = "dead" then -- jump 53
me.pShadowSpr.castNum = 0
tSize = [62, 40, 32, 0]
me.pMember.regPoint = point(0, (tSize[2] + tSize[4]))

else if me.pShadowSpr.member <> me.pDefShadowMem then
me.pShadowSpr.member = me.pDefShadowMem

end if
end if
if me.pBuffer.width <> tSize[1] or me.pBuffer.height <> tSize[2] then
me.pMember.image = image(tSize[1], tSize[2], tSize[3])
me.pMember.regPoint = point(0, tSize[2] + tSize[4])
me.pSprite.width = tSize[1]
me.pSprite.height = tSize[2]
me.pMatteSpr.width = tSize[1]
me.pMatteSpr.height = tSize[2]
me.pBuffer = image(tSize[1], tSize[2], tSize[3])
repeat with tPart in me.pPartList
tPart.resetMemberCache()

end repeat
end if
me.pMember.regPoint = point(0, me.pMember.getProp(#regPoint, 2))
me.pShadowFix = FALSE
if me.pSprite.flipH then
me.pSprite.flipH = FALSE
me.pMatteSpr.flipH = FALSE
me.pShadowSpr.flipH = FALSE

end if
if pAvatarAction[#tag] = "dead" then
if pAvatarAction[#frame] = 1 then
if pAvatarAction[#facedown] then
case pAvatarAction[#direction] of
0: tpoint = point(-8, 0)
2: tpoint = point(-10, -2)
4: tpoint = point(35, -5)
6: tpoint = point(37, 0)

end case
else
case pAvatarAction[#direction] of
0: tpoint = point(10, -3)
2: tpoint = point(30, 0)
4: tpoint = point(0, 0)
6: tpoint = point(17, -3)

end case
end if
else
if pAvatarAction[#facedown] then
case pAvatarAction[#direction] of
0: tpoint = point(-15, -10)
2: tpoint = point(-12, -36)
4: tpoint = point(38, -36)
6: tpoint = point(42, -10)

end case
else
case pAvatarAction[#direction] of
0: tpoint = point(38, -27)
2: tpoint = point(37, -3)
4: tpoint = point(-7, -3)
6: tpoint = point(-10, -26)

end case
end if
end if
me.pMember.regPoint = me.pMember.regPoint + tpoint

end if
if me.pCorrectLocZ then tOffZ = (me.pLocH + me.pRestingHeight) * 1000 + 2
else tOffZ = 2

me.pSprite.locH = me.getProp(#pScreenLoc, 1)
me.pSprite.locV = me.getProp(#pScreenLoc, 2)
me.pMatteSpr.loc = me.pSprite.loc
me.pShadowSpr.loc = (me.pSprite.loc + [me.pShadowFix, 0])
if me.pBaseLocZ <> 0 then me.pSprite.locZ = me.pBaseLocZ
else me.pSprite.locZ = me.getProp(#pScreenLoc, 3) + tOffZ + me.pBaseLocZ

me.pMatteSpr.locZ = me.pSprite.locZ + 1
me.pShadowSpr.locZ = me.pSprite.locZ - 3
me.pUpdateRect = rect(0, 0, 0, 0)
me.pBuffer.fill(me.pBuffer.rect, me.pAlphaColor)
call(#update, me.pPartList)
me.pMember.image.copyPixels(me.pBuffer, me.pUpdateRect, me.pUpdateRect)
me.setOwnHiliter(TRUE)
return TRUE

end

on setHumanSpriteLoc me
tOffZ = 2
if ilk(me.pSprite) <> #sprite then return FALSE

me.pSprite.locH = me.getProp(#pScreenLoc, 1)
me.pSprite.locV = me.getProp(#pScreenLoc, 2)
me.pSprite.locZ = (me.getProp(#pScreenLoc, 3) + tOffZ)
me.pMatteSpr.loc = me.pSprite.loc
me.pMatteSpr.locZ = (me.pSprite.locZ + 1)
me.pShadowSpr.loc = (me.pSprite.loc + [me.pShadowFix, 0])
me.pShadowSpr.locZ = (me.pSprite.locZ - 3)
return TRUE

end

on Refresh me, tX, tY, tH
call(#defineDir, me.pPartList, me.pDirection)
me.arrangeParts()
me.pChanges = TRUE
return TRUE

end

on resetValues me, tX, tY, tH, tDirHead, tDirBody
me.pMainAction = "std"
me.pLocX = tX
me.pLocY = tY
me.pLocH = tH
if me.pGeometry = void() then return FALSE

me.pScreenLoc = me.pGeometry.getScreenCoordinate(tX, tY, tH)
me.pMoving = FALSE
call(#reset, me.pPartList)
me.pDirection = tDirBody
me.pHeadDir = tDirHead
me.pChanges = TRUE
return TRUE

end

on setBlendInvincible me
tsprite = me.pSprite
if ilk(tsprite) <> #sprite then return FALSE

if tsprite.blend < 100 then tsprite.blend = 100
else tsprite.blend = 20

return TRUE

end

on arrangeParts me
if me.pPartList = void() then return FALSE
if me.count(#pPartList) = 0 then return FALSE

case TRUE of
(pAvatarAction[#tag] = "dead"): me.arrangeParts_Death()
(me.pMainAction = "pck"): me.arrangeParts_Pick()
otherwise: callAncestor(#arrangeParts, me)

end case
repeat with i = 1 to me.count(#pPartList) then
me.setProp(#pPartIndex, me.getPropRef(#pPartList, i).pPart, i)

end repeat
return TRUE

end

on arrangeParts_Pick me, tXFix, tYFix
if me.pPartList = void() then return FALSE

tDirection = me.pDirection - (me.pDirection mod 2)
repeat with tPart in me.pPartList
if pActionPartList.findPos(tPart.pPart) = FALSE then
tPart.pXFix = 3
tPart.pYFix = 5

end if
end repeat
me.pChanges = TRUE
return TRUE

end

on arrangeParts_Death me
if me.pPartList = void() then return FALSE

if pAvatarAction[#facedown] then
case pAvatarAction[#direction] of
0:
tHeadBelow = TRUE
tFace = point(-3, 11)

2:
tFace = point(1, 9)

4:
tFace = point(3, 9)

6:
tHeadBelow = TRUE
tFace = point(-1, 10)

end case
else
case pAvatarAction[#direction] of
0:
tHeadBelow = TRUE
tFace = point(-2, 10)

2:
tFace = point(19, 8)

4:
tFace = point(18, 7)

6:
tHeadBelow = TRUE
tFace = point(-1, 10)

end case
end if
tActionParts = []
repeat with tPart in pActionPartList
if not voidp(me.getProp(#pPartIndex, tPart)) then
tActionParts.add(me.getProp(#pPartList, me.getProp(#pPartIndex, tPart)))

end if
end repeat
repeat with i = me.count(#pPartList) down to 1
tPart = me.getProp(#pPartList, i)
if pActionPartList.findPos(tPart.pPart) > 0 then
me.pPartList.deleteAt(i)

end if
end repeat
tHeadBelow = TRUE
repeat with i = 1 to tActionParts.count
tPart = tActionParts[i]
if tHeadBelow then me.pPartList.append(tPart)
else me.pPartList.addAt(i, tPart)

end repeat
repeat with tPart in me.pPartList
if pActionPartList.findPos(tPart.pPart) = 0 then
tPart.pXFix = tFace.locH
tPart.pYFix = tFace.locV

end if
end repeat
me.pChanges = TRUE
return TRUE

end

on getPartListNameBase me
return "snowwar.human.parts"

end

on setPartLists me, tmodels
tmodels = me.fixSnowWarFigure(tmodels)
callAncestor(#setPartLists, me, tmodels)
return TRUE

end

on fixSnowWarFigure me, tFigure
repeat with tPartSymbol in pActionPartList
if voidp(tFigure[tPartSymbol]) then
tFigure[tPartSymbol] = [:]

end if
tFigure[tPartSymbol]["model"] = "snowwar"
tFigure[tPartSymbol]["color"] = rgb("EEEEEE")

end repeat
if GetObject(#session).GET("game_number_of_teams") > 1 then
tTeamColor = rgb(string(getVariable("snowwar.teamcolors.team" & pTeamId)))

else if not voidp(tFigure["ch"]) then
tTeamColor = tFigure["ch"]["color"]

else
tTeamColor = rgb("EEEEEE")

end if
if not voidp(tFigure["sh"]) then tFigure["sh"]["color"] = tTeamColor

return tFigure

end

on setOwnHiliter me, tstate
if not GetObject(#session).exists("user_index") then return FALSE
if me.getID() <> GetObject(#session).GET("user_index") then return FALSE

if pHiliteSpriteNum = 0 then
if not tstate then return TRUE
if pTeamId = void() then return FALSE

pHiliteSpriteNum = reserveSprite("sw_own_hiliter_" & me.getID())
if pHiliteSpriteNum = FALSE then return FALSE

tsprite = sprite(pHiliteSpriteNum)
tmember = member(getmemnum("sw_avatar_hilite_team_" & pTeamId))
if tmember.type = #bitmap then tsprite.member = tmember

tsprite.visible = TRUE
tsprite.ink = 36

else
tsprite = sprite(pHiliteSpriteNum)
tsprite.visible = tstate

end if
tsprite.locZ = me.getProp(#pScreenLoc, 3) + 1
tsprite.loc = point(me.getProp(#pScreenLoc, 1) + tsprite.member.width / 2, me.getProp(#pScreenLoc, 2))

end

on getPicture me, tImg
return me.getPartialPicture(#Full, tImg, 4, "sh")

end

on getTeamId me
return pTeamId

end

on getAvatarId me
return pAvatarId

end

on action_mv me, tProps
me.pMoveTime = 500
me.pMainAction = "wlk"
me.pMoving = TRUE
tDelim = the itemDelimiter
the itemDelimiter = ","
tloc = tProps.getProp(#word, 2)
tLocX = integer(tloc.getProp(#item, 1))
tLocY = integer(tloc.getProp(#item, 2))
tLocH = integer(tloc.getProp(#item, 3))
the itemDelimiter = tDelim
if me.pGeometry = FALSE then return FALSE

me.pStartLScreen = me.pGeometry.getScreenCoordinate(me.pLocX, me.pLocY, me.pLocH)
me.pDestLScreen = me.pGeometry.getScreenCoordinate(tLocX, tLocY, tLocH)
me.pMoveStart = the milliSeconds
call(#defineAct, me.getDefinedPartList(pActionPartList), "wlk")

end
